/* Copyright (C) 2004-2006 The SSI Project. All rights reserved.
   http://ssi.is.s.u-tokyo.ac.jp/

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
   terms and conditions for the use of this software.
*/

#ifndef __LIS_MPI_H__
#define __LIS_MPI_H__




#ifdef __cplusplus
extern "C"
{
#endif

	extern int lis_commtable_create(LIS_MATRIX A);
	extern void lis_commtable_destroy(LIS_COMMTABLE table);
	extern int lis_commtable_duplicate(LIS_COMMTABLE tin, LIS_COMMTABLE *tout);
	extern int lis_commtable_duplicateM(LIS_MATRIX Ain, LIS_MATRIX *Aout);
	extern int lis_send_recv(LIS_COMMTABLE commtable, LIS_SCALAR x[]);
	extern int lis_reduce(LIS_COMMTABLE commtable, LIS_SCALAR x[]);
	extern int lis_send_recv_mp(LIS_COMMTABLE commtable, LIS_VECTOR X);
	extern int lis_reduce_mp(LIS_COMMTABLE commtable, LIS_VECTOR X);
	extern int lis_matrix_g2l(LIS_MATRIX A);
		extern int lis_matrix_g2l_crs(LIS_MATRIX A);
		extern int lis_matrix_g2l_rco(LIS_MATRIX A);

#ifdef __cplusplus
}
#endif

#endif
