/* Copyright (C) 2004-2006 The SSI Project. All rights reserved.
   http://ssi.is.s.u-tokyo.ac.jp/

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
   terms and conditions for the use of this software.
*/

#ifndef __LIS_PRECON_H__
#define __LIS_PRECON_H__


#define lis_psolve(solver,b,x)		lis_psolve_xxx[solver->precon->precon_type](solver,b,x)
#define lis_psolvet(solver,b,x)		lis_psolvet_xxx[solver->precon->precon_type](solver,b,x)




#ifdef __cplusplus
extern "C"
{
#endif
	extern int lis_precon_init(LIS_PRECON precon);
	extern int lis_precon_create(LIS_SOLVER solver, LIS_PRECON *precon);
	extern int lis_precon_destroy(LIS_PRECON precon);

	extern LIS_PRECON_CREATE_XXX lis_precon_create_xxx[];
	extern LIS_PSOLVE_XXX lis_psolve_xxx[];
	extern LIS_PSOLVET_XXX lis_psolvet_xxx[];
	/*******************/
	/* NONE            */
	/*******************/
	extern int lis_precon_create_none(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_none(LIS_SOLVER solver, LIS_VECTOR b, LIS_VECTOR x);
	extern int lis_psolvet_none(LIS_SOLVER solver, LIS_VECTOR b, LIS_VECTOR x);
	/*******************/
	/* Jacobi          */
	/*******************/
	extern int lis_precon_create_jacobi(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_jacobi(LIS_SOLVER solver, LIS_VECTOR b, LIS_VECTOR x);
	extern int lis_psolvet_jacobi(LIS_SOLVER solver, LIS_VECTOR b, LIS_VECTOR x);
	/*******************/
	/* ILU             */
	/*******************/
	extern int lis_precon_create_ilu(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_ilu(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_ilu(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);

	extern int lis_precon_create_ilu0(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_precon_create_ilu0_crs(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_precon_create_ilu0_bsr(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_ilu0(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_ilu0(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);

	extern int lis_precon_create_iluk(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_precon_create_iluk_crs(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_iluk(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_iluk(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	/*******************/
	/* SSOR            */
	/*******************/
	extern int lis_precon_create_ssor(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_ssor(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_ssor(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	/*******************/
	/* Hybrid          */
	/*******************/
	extern int lis_precon_create_hybrid(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_hybrid(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_hybrid(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	/*******************/
	/* I+S             */
	/*******************/
	extern int lis_precon_create_is(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_precon_create_is_crs(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_is(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_is(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	/*******************/
	/* SAINV           */
	/*******************/
	extern int lis_precon_create_sainv(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_precon_create_sainv_crs(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_sainv(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_sainv(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	/*******************/
	/* SAAMG           */
	/*******************/
	extern int lis_precon_create_saamg(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_saamg(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_saamg(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	/*******************/
	/* Crout ILU       */
	/*******************/
	extern int lis_precon_create_iluc(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_precon_create_iluc_crs(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_iluc(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_iluc(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	/********************/
	/* Additive Schwarz */
	/********************/
	extern int lis_precon_create_adds(LIS_SOLVER solver, LIS_PRECON precon);
	extern int lis_psolve_adds(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);
	extern int lis_psolvet_adds(LIS_SOLVER solver, LIS_VECTOR B, LIS_VECTOR X);

#ifdef __cplusplus
}
#endif
#endif
