module data_structure_for_AMG
  implicit none
  include 'precision.inc'
  
  integer, parameter :: SWITCH_SIZE    = 1700
  integer, parameter :: MAX_LEVEL_SIZE = 10
  integer, parameter :: MIN_NODE_SIZE  = 90
  
  type row_node
     INTEGER(kind=kint) :: column
     REAL(kind=kreal)   :: value
  end type row_node
  
  type INTER_LEVEL_OPERATOR
     integer(kind=kint) :: ROW_SIZE
     integer(kind=kint),  pointer :: IN(:)
     integer(kind=kint),  pointer :: CN(:)
     real   (kind=kreal), pointer :: V(:)
  end type INTER_LEVEL_OPERATOR
  
  type COMMUNICATION_TABLE
     integer(kind=kint) :: NEIBPETOT
     integer(kind=kint), pointer :: NEIBPE(:)
     integer(kind=kint), pointer :: STACK_IMPORT(:)
     integer(kind=kint), pointer :: STACK_EXPORT(:)
     integer(kind=kint), pointer :: NOD_IMPORT(:)
     integer(kind=kint), pointer :: NOD_EXPORT(:)
  end type COMMUNICATION_TABLE
  
  type DATA_FOR_EACH_LEV
     integer(kind=kint ) :: N,NP,NPL,NPU
     integer(kind=kint ), pointer :: INU(:),INL(:)
     integer(kind=kint ), pointer :: IAU(:),IAL(:)
     real   (kind=kreal), pointer :: AU(:),AL(:),D(:),X(:),B(:)
     
     type(COMMUNICATION_TABLE) :: COMM_TABLE
     type(COMMUNICATION_TABLE) :: INT_LVL_TABLE
     type(INTER_LEVEL_OPERATOR), pointer :: R, P

  end type DATA_FOR_EACH_LEV
  
  type (DATA_FOR_EACH_LEV) :: HIERARCHICAL_DATA(MAX_LEVEL_SIZE)
  
!C Rate_Of_Space * mesh size is the width of the next coarser 
!C level's restriction

  real (kind=kreal),  parameter :: EPS = 1.E-10
  real (kind=kreal),  parameter :: EPS_COARSEST = 1.E-5
  INTEGER(kind=kint), parameter :: NODE_RECORD_SIZE=300
  LOGICAL :: SYMMETRIC_FLAG
  
  INTEGER*8 :: pspcommf
  INTEGER(kind=kint),pointer :: rowdistbx(:)
  INTEGER(kind=kint) :: ldb,ldx,nrhs
  INTEGER(kind=kint) :: ioptions(16)
  REAL(kind=kreal)   :: doptions(16)
  REAL(kind=kreal),pointer        :: coarsest_X(:,:),coarsest_B(:,:)

end module data_structure_for_AMG






